%global pkg_version %(echo %version | tr . _)
Name:          smack
Version:       3.2.2
Release:       2%{?dist}
Summary:       Open Source XMPP (Jabber) client library
Group:         Development/Libraries
License:       ASL 2.0
URL:           http://www.igniterealtime.org/projects/smack/index.jsp
# http://svn.igniterealtime.org/svn/repos/smack/tags/
Source0:       http://download.igniterealtime.org/smack/%{name}_src_%{pkg_version}.tar.gz
# originally taken from http://repo1.maven.org/maven2/org/igniterealtime/smack/
# change version
# add xpp3
Source1:       %{name}-%{version}.pom
# add jzlib as system deps
Source2:       %{name}x-%{version}.pom
Source3:       %{name}x-debug-%{version}.pom
# unavailable test resources
# wget -O smack-3.2.2-test-config-test-case.xml http://svn.igniterealtime.org/svn/repos/smack/tags/smack_3_2_2/test/config/test-case.xml
Source4:       %{name}-%{version}-test-config-test-case.xml

# use system libraries
# disable jzlib and xpp3 repackage

# disable smack jingle extension. cause: unavailable deps

# jingle/extension/build/lib/Speex.jar mil.jfcom.cie.media ?
# jingle/extension/build/lib/jmf.jar replace with fmj
# jingle/extension/build/lib/commons-logging-1.1.jar
# jingle/extension/build/lib/commons-logging-adapters-1.1.jar
# jingle/extension/build/lib/commons-logging-api-1.1.jar
# jingle/extension/build/lib/jspeex-0.9.7-jfcom.jar org.xiph.speex
# jingle/extension/build/merge/jstun.jar
# jingle/extension/build/lib/junit.jar

# remove classpath from manifest files
# fix javadoc link
# fix build/javadoc/tests classpath
Patch0:        %{name}-%{version}-build.patch

BuildRequires: java-devel
BuildRequires: java-javadoc
BuildRequires: jpackage-utils

BuildRequires: ant
BuildRequires: ant-contrib
BuildRequires: ant-junit
BuildRequires: aqute-bnd
BuildRequires: junit
BuildRequires: jzlib
BuildRequires: xmlunit
BuildRequires: xpp3

Requires:      jzlib
Requires:      xpp3

Requires:      java
Requires:      jpackage-utils
BuildArch:     noarch

%description
Smack is an Open Source XMPP (Jabber) client library for instant
messaging and presence. A pure Java library, it can be embedded
into your applications to create anything from a full XMPP client
to simple XMPP integrations such as sending notification messages and
presence-enabling devices.

%package javadoc
Group:         Documentation
Summary:       Javadoc for %{name}
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}_src_%{pkg_version}
# cleanup
find . -name "*.class" -print -delete
find . -name "*.dll" -print -delete
find . -name "*.jar" -print  -delete

# remove prebuilt documentation
rm -rf javadoc/* documentation/*

%patch0 -p0

mkdir -p test/config
cp -p %{SOURCE4} test/config/test-case.xml
# tests problem:
#    [junit] XMPPError connecting to localhost:5222.: remote-server-error(502)
#            XMPPError connecting to localhost:5222.
#    [junit]   -- caused by: java.net.ConnectException: Connection refused
# remove this file unavailable class, in this release isn't available. error: cannot find symbol
#    [javac] import org.jivesoftware.smackx.bytestreams.socks5.Socks5PacketUtils;
rm -r test/org/jivesoftware/smackx/bytestreams/socks5/Socks5ByteStreamTest.java
# these tests fails
rm -r test/org/jivesoftware/smack/ChatTest.java \
 test/org/jivesoftware/smack/FloodTest.java \
 test/org/jivesoftware/smack/IQTest.java \
 test/org/jivesoftware/smack/LoginTest.java \
 test/org/jivesoftware/smack/MessageTest.java \
 test/org/jivesoftware/smack/PacketReaderTest.java \
 test/org/jivesoftware/smack/PresenceTest.java \
 test/org/jivesoftware/smack/ReconnectionTest.java \
 test/org/jivesoftware/smack/RosterListenerTest.java \
 test/org/jivesoftware/smack/RosterSmackTest.java \
 test/org/jivesoftware/smack/RosterInitializedBeforeConnectTest.java \
 test/org/jivesoftware/smack/packet/PrivacyTest.java \

%build

%ant -f build/build.xml jar javadoc test

%install

mkdir -p %{buildroot}%{_javadir}/%{name}
install -pm 644 target/%{name}.jar %{buildroot}%{_javadir}/%{name}/
install -pm 644 target/%{name}x.jar %{buildroot}%{_javadir}/%{name}/
install -pm 644 target/%{name}x-debug.jar %{buildroot}%{_javadir}/%{name}/

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}.pom
%add_maven_depmap JPP.%{name}-%{name}.pom %{name}/%{name}.jar -a "jivesoftware:%{name}"
install -pm 644 %{SOURCE2} %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}x.pom
%add_maven_depmap JPP.%{name}-%{name}x.pom %{name}/%{name}x.jar -a "jivesoftware:%{name}x"
install -pm 644 %{SOURCE3} %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}x-debug.pom
%add_maven_depmap JPP.%{name}-%{name}x-debug.pom %{name}/%{name}x-debug.jar -a "jivesoftware:%{name}x-debug"

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -rp target/javadoc/* %{buildroot}%{_javadocdir}/%{name}

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}*.jar
%{_mavenpomdir}/JPP.%{name}-%{name}*.pom
%{_mavendepmapfragdir}/%{name}
%doc README.html changelog.html

%files javadoc
%{_javadocdir}/%{name}
%doc README.html

%changelog
* Wed Dec 26 2012 gil cattaneo <puntogil@libero.it> 3.2.2-2
- enabled unit-tests

* Thu Sep 06 2012 gil cattaneo <puntogil@libero.it> 3.2.2-1
- initial rpm